# Generated by CodiumAI

from agent.use_cases.signer import sign_verifiable_credentials
import pytest

# Generated by CodiumAI

from agent.use_cases.signer import is_valid_object_type

import pytest


class TestIsKnownObjectType:
    #  Returns False if the input is None.
    def test_none_input(self):
        # Given
        object_type = None

        # When
        result = is_valid_object_type(object_type)

        # Then
        assert result is False

    #  Returns False if the input is an empty string.
    def test_empty_string(self):
        # Given
        object_type = ""

        # When
        result = is_valid_object_type(object_type)

        # Then
        assert result is False

    #  Returns False if the input is an integer.
    def test_integer_input(self):
        # Given
        object_type = 123

        # When
        result = is_valid_object_type(object_type)

        # Then
        assert result is False

    #  Returns False if the input is a float.
    def test_float_input(self):
        # Given
        object_type = 3.14

        # When
        result = is_valid_object_type(object_type)

        # Then
        assert result is False

    #  Returns False if the input is a boolean.
    def test_boolean_input(self):
        # Given
        object_type = True

        # When
        result = is_valid_object_type(object_type)

        # Then
        assert result is False

    #  Returns False if the input is a dictionary.
    def test_dictionary_input(self):
        # Given
        object_type = {"key": "value"}

        # When
        result = is_valid_object_type(object_type)

        # Then
        assert result is False

    #  Returns False if the input is a list containing an integer.
    def test_list_with_integer_input(self):
        # Given
        object_type = [1, 2, 3]

        # When
        result = is_valid_object_type(object_type)

        # Then
        assert result is False

    #  Returns False if the input is a list containing an unknown ontology.
    def test_list_with_unknown_ontology(self):
        # Given
        object_type = ["location"]

        # When
        result = is_valid_object_type(object_type)

        # Then
        assert result is False

    #  Returns False if the input is a string that is an unknown ontology.
    def test_string_with_unknown_ontology(self):
        # Given
        object_type = "location"

        # When
        result = is_valid_object_type(object_type)

        # Then
        assert result is False

    #  Returns True if the input is a list containing known ontologies.
    def test_list_with_known_ontology(self):
        # Given
        object_type = ["Location"]

        # When
        result = is_valid_object_type(object_type)

        # Then
        assert result is True

    #  Returns True if the input is a string that is an known ontology.
    def test_string_with_known_ontology(self):
        # Given
        object_type = "Location"

        # When
        result = is_valid_object_type(object_type)

        # Then
        assert result is True

class TestSignVerifiableCredentials:

    #  Signs a none JSON-LD object
    def test_signs_none_jsonld_should_raise_value_error(self):
        # Given
        jsonld = None

        # When
        with pytest.raises(ValueError):
            sign_verifiable_credentials(jsonld)

    #  Signs an empty JSON-LD object
    def test_signs_empty_json_ld_should_raise_value_error(self):
        # Given
        jsonld = {}

        # When
        with pytest.raises(ValueError):
            sign_verifiable_credentials(jsonld)

    #  Signs a JSON-LD object with an invalid type
    def test_signs_invalid_type_value_should_raise_value_error(self):
        # Given
        jsonld = {
            "type": 12
        }

        # When
        with pytest.raises(ValueError):
            sign_verifiable_credentials(jsonld)

    #  Signs a JSON-LD object with an empty type value
    def test_signs_empty_type_value_should_return_none(self):
        # Given
        jsonld = {
            "type": ""
        }

        # When
        with pytest.raises(ValueError):
            sign_verifiable_credentials(jsonld)

    #  Signs a JSON-LD object with an empty type value
    def test_signs_empty_type_value_list_should_raise_value_error(self):
        # Given
        jsonld = {
            "type": []
        }

        # When
        with pytest.raises(ValueError):
            sign_verifiable_credentials(jsonld)

    #  Signs a JSON-LD object with an empty type value
    def test_signs_empty_type_value_in_list_should_raise_value_error(self):
        # Given
        jsonld = {
            "type": [""]
        }

        # When
        with pytest.raises(ValueError):
            sign_verifiable_credentials(jsonld)

    #  Signs a JSON-LD object with an unknown type
    def test_signs_unknown_type_value_should_raise_value_error(self):
        # Given
        jsonld = {
            "type": "12"
        }

        # When
        with pytest.raises(ValueError):
            sign_verifiable_credentials(jsonld)
